/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MainFrame.java
 *
 * Created on 12 nov. 2009, 15:38:14
 */

package semanticassignment2;

import java.util.regex.Pattern;


/**
 *
 * @author Thomas
 */
public class MainFrame extends javax.swing.JFrame {

    private RequestHandler _requestHdl=null;
    private String _PremadeRequest=null;
    private String _PMRequestDescription=null;
    private int _PreMadeRequestNumber = 6;
    private String _resultHTML=null;
    private String _resultXML=null;
    
    /** Creates new form MainFrame */
    public MainFrame() {
        initComponents();
        initParam();        
    }

    public MainFrame(RequestHandler requestHdl, Boolean ErrorConnexion) {
        initComponents();
        initParam();
       if (ErrorConnexion) {
                Lbl_Status.setText("The OWL file is not loaded, please verify your connexion and restart the application ..");
                PanelPreMadeRequest.hide();
                PanelResults.hide();
        }
        _requestHdl = requestHdl;
        Txt_Panel.setContentType("text/html");
    }    

    public void initParam() {
        this.setTitle("Semantic Technologies - Assignment #2: Esports ontology - Developped by T.Dupuis");
        
        String[] PMRequest = new String[_PreMadeRequestNumber];
        for (int i=0;i<_PreMadeRequestNumber;i++) {
            int varTmp = i + 1;
            PMRequest[i] = "Premade request " + varTmp;
        }
        RequestPicker.setModel(new javax.swing.DefaultComboBoxModel(PMRequest));
        //set the defaut PremadeRequest :
            _PremadeRequest = new String("PREFIX esports: <http://www.enib-erasmus.fr/Semantic/ThomasDupuis/assignment_esports.rdf-xml.owl#>" +
             "SELECT ?NickName ?FirstName ?LastName  ?Age " +
             "WHERE { ?Player esports:Age ?Age FILTER (?Age > 21) " +
             ". ?Player a esports:Player . " +
             "?Player esports:hasForHumanName ?HumanName . " +
             "?HumanName a esports:HumanName . " +
             "?HumanName esports:FirstName ?FirstName . " +
             "?HumanName esports:LastName ?LastName . " +
             "?HumanName esports:Nickname ?NickName . " +
             "}");
        TxtArea_Request.setText(_PremadeRequest);
        _PMRequestDescription = "Return all the players who are more than 21 years old";
        Lbl_Description.setText(_PMRequestDescription);

        String[] ResultTypeString = new String[2];
        ResultTypeString[0] = "HTML visualization";
        ResultTypeString[1] = "XML visualization";
        ResultType.setModel(new javax.swing.DefaultComboBoxModel(ResultTypeString));        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        PanelPreMadeRequest = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        TxtArea_Request = new javax.swing.JTextArea();
        RequestPicker = new javax.swing.JComboBox();
        Bt_Perform = new javax.swing.JButton();
        Lbl_Description = new javax.swing.JLabel();
        Bt_Reset = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        PanelResults = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        Txt_Panel = new javax.swing.JTextPane();
        ResultType = new javax.swing.JComboBox();
        Lbl_Status = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setForeground(new java.awt.Color(255, 255, 255));

        PanelPreMadeRequest.setBorder(javax.swing.BorderFactory.createTitledBorder("Type your request here"));

        TxtArea_Request.setColumns(20);
        TxtArea_Request.setRows(5);
        jScrollPane1.setViewportView(TxtArea_Request);

        RequestPicker.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        RequestPicker.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RequestPickerActionPerformed(evt);
            }
        });

        Bt_Perform.setText("Perform");
        Bt_Perform.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Bt_PerformActionPerformed(evt);
            }
        });

        Lbl_Description.setText("Description");

        Bt_Reset.setText("Reset");
        Bt_Reset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Bt_ResetActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout PanelPreMadeRequestLayout = new javax.swing.GroupLayout(PanelPreMadeRequest);
        PanelPreMadeRequest.setLayout(PanelPreMadeRequestLayout);
        PanelPreMadeRequestLayout.setHorizontalGroup(
            PanelPreMadeRequestLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PanelPreMadeRequestLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(PanelPreMadeRequestLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, PanelPreMadeRequestLayout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 1026, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(PanelPreMadeRequestLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Bt_Reset, javax.swing.GroupLayout.DEFAULT_SIZE, 81, Short.MAX_VALUE)
                            .addComponent(Bt_Perform, javax.swing.GroupLayout.DEFAULT_SIZE, 81, Short.MAX_VALUE)))
                    .addGroup(PanelPreMadeRequestLayout.createSequentialGroup()
                        .addComponent(RequestPicker, javax.swing.GroupLayout.PREFERRED_SIZE, 276, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(Lbl_Description, javax.swing.GroupLayout.PREFERRED_SIZE, 805, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        PanelPreMadeRequestLayout.setVerticalGroup(
            PanelPreMadeRequestLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PanelPreMadeRequestLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(PanelPreMadeRequestLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(RequestPicker, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Lbl_Description))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(PanelPreMadeRequestLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(PanelPreMadeRequestLayout.createSequentialGroup()
                        .addComponent(Bt_Perform, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(8, 8, 8)
                        .addComponent(Bt_Reset, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jLabel1.setText("Use the pre-made request or type your own request to show instances of the E-Sports ontology");

        PanelResults.setBorder(javax.swing.BorderFactory.createTitledBorder("Results:"));

        jScrollPane2.setViewportView(Txt_Panel);

        ResultType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        ResultType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ResultTypeActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout PanelResultsLayout = new javax.swing.GroupLayout(PanelResults);
        PanelResults.setLayout(PanelResultsLayout);
        PanelResultsLayout.setHorizontalGroup(
            PanelResultsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(PanelResultsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(PanelResultsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ResultType, javax.swing.GroupLayout.PREFERRED_SIZE, 276, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 1103, Short.MAX_VALUE))
                .addContainerGap())
        );
        PanelResultsLayout.setVerticalGroup(
            PanelResultsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, PanelResultsLayout.createSequentialGroup()
                .addComponent(ResultType, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 12, Short.MAX_VALUE)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 345, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        Lbl_Status.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Lbl_Status.setForeground(new java.awt.Color(255, 0, 0));

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(27, 27, 27)
                        .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 819, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(PanelPreMadeRequest, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(PanelResults, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(119, 119, 119)
                        .addComponent(Lbl_Status, javax.swing.GroupLayout.PREFERRED_SIZE, 907, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(12, 12, 12)
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(PanelPreMadeRequest, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Lbl_Status, javax.swing.GroupLayout.PREFERRED_SIZE, 11, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(1, 1, 1)
                .addComponent(PanelResults, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents



    private void Bt_PerformActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Bt_PerformActionPerformed
      String[]_resultsRequest = _requestHdl.makeRequest(TxtArea_Request.getText());
      _resultHTML= _resultsRequest[0];
      _resultXML= _resultsRequest[1];
      ResultTypeActionPerformed(null);
    }//GEN-LAST:event_Bt_PerformActionPerformed

    private void RequestPickerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RequestPickerActionPerformed
        String PMRequestPicker= (String)RequestPicker.getSelectedItem();
        String REGEX = " ";
        Pattern p = Pattern.compile(REGEX);
        String[] stringTool = p.split(PMRequestPicker);
        int PMRequestNumber = Integer.parseInt(stringTool[2]);

        switch (PMRequestNumber) {
            case 1 : //DONE
            _PMRequestDescription = new String ("Return all the players who are more than 21 years old");
            _PremadeRequest = new String("PREFIX esports: <http://www.enib-erasmus.fr/Semantic/ThomasDupuis/assignment_esports.rdf-xml.owl#>" +
             "SELECT ?NickName ?FirstName ?LastName  ?Age " +
             "WHERE { ?Player esports:Age ?Age FILTER (?Age > 21) " +
             ". ?Player a esports:Player . " +
             "?Player esports:hasForHumanName ?HumanName . " +
             "?HumanName a esports:HumanName . " +
             "?HumanName esports:FirstName ?FirstName . " +
             "?HumanName esports:LastName ?LastName . " +
             "?HumanName esports:Nickname ?NickName . " +
             "}");
                break;

            case 2 : // DONE
            _PMRequestDescription = new String ("Return all the players who have a team competiting in a Lan Party which is named \"World Cyber Games 2009\"");
            _PremadeRequest = new String("PREFIX esports: <http://www.enib-erasmus.fr/Semantic/ThomasDupuis/assignment_esports.rdf-xml.owl#>" +
             "SELECT ?NickName ?FirstName ?LastName " +
             "WHERE { ?Player esports:hasTeam ?Team . " +
             "?Player a esports:Player . " +
             "?Team a esports:Team . " +
             "?Team esports:engagedIn ?LanParty . " +
             "?LanParty a esports:LanParty . " +
             "?LanParty esports:isNamed ?ThingName . " +
             "?ThingName a esports:ThingName . " +
             "?ThingName esports:simpleName ?simpleName " +
             "FILTER regex(?simpleName, \"World Cyber Games 2009\") . " +
             "?Player esports:hasForHumanName ?HumanName . " +
             "?HumanName a esports:HumanName . " +
             "?HumanName esports:FirstName ?FirstName . " +
             "?HumanName esports:LastName ?LastName . " +
             "?HumanName esports:Nickname ?NickName . " +
             "} ");
                break;

            case 3 : //DONE
              _PMRequestDescription = new String ("Return all the American teams");
              _PremadeRequest = new String("PREFIX esports: <http://www.enib-erasmus.fr/Semantic/ThomasDupuis/assignment_esports.rdf-xml.owl#>" +
             "SELECT ?TeamName ?Nationality " +
             "WHERE { ?Team esports:Nationality ?Nationality " +
                      "FILTER regex(?Nationality, \"American\") . " +
                      "?Team a esports:Team . " +
                      "?Team esports:isNamed ?name . " +
                      "?name esports:simpleName ?TeamName" +
                      "} ");
                break;

            case 4 : //DONE
             _PMRequestDescription = new String ("Return the website of the equipment's brand of players who play in the WCG 2009");
             _PremadeRequest = new String("PREFIX esports: <http://www.enib-erasmus.fr/Semantic/ThomasDupuis/assignment_esports.rdf-xml.owl#>" +
             "SELECT ?BrandName ?Urlvalue " +
             "WHERE { ?Player esports:hasTeam ?Team . " +
             "?Player a esports:Player . " +
             "?Team a esports:Team . " +
             "?Team esports:engagedIn ?LanParty . " +
             "?LanParty a esports:LanParty . " +
             "?LanParty esports:isNamed ?ThingName . " +
             "?ThingName a esports:ThingName . " +
             "?ThingName esports:simpleName ?simpleName " +
             "FILTER regex(?simpleName, \"World Cyber Games 2009\") . " +
             "?Player esports:hasEquipment ?MaterialEquipment . " +
             "?MaterialEquipment a esports:MaterialEquipment . " +
             "?MaterialEquipment esports:hasForBrand ?Brand . " +
             "?Brand a esports:Brand . " +
             "?Brand esports:isNamed ?ThingNameB . " +
             "?ThingNameB esports:simpleName ?BrandName . " +
             "?Brand esports:hasWebsite ?Website . " +
             "?Website a esports:Website . " +
             "?Website esports:hasURL ?Url . " +
             "?Url a esports:URL . " +
             "?Url esports:URLValue ?Urlvalue } ");
                break;

            case 5 : //DONE
             _PMRequestDescription = new String ("Show all the prices of the equipment");
             _PremadeRequest = new String("PREFIX esports: <http://www.enib-erasmus.fr/Semantic/ThomasDupuis/assignment_esports.rdf-xml.owl#>" +
             "SELECT  ?EquipmentName ?MoneyValue ?Currency " +
             "WHERE { ?MaterialEquipment esports:cost ?Money . " +
                     "?MaterialEquipment a esports:MaterialEquipment . " +
                     "?MaterialEquipment esports:isNamed ?Name . " +
                     "?Name esports:simpleName ?EquipmentName . " +
                     "?Money a esports:Money . " +
                     "?Money esports:MoneyValue ?MoneyValue . " +
                     "?Money esports:Currency ?Currency }");
                break;

            case 6 : //DONE
              _PMRequestDescription = new String ("Return all the teams and their nationality");
              _PremadeRequest = new String("PREFIX esports: <http://www.enib-erasmus.fr/Semantic/ThomasDupuis/assignment_esports.rdf-xml.owl#>" +
             "SELECT ?TeamName ?Nationality " +
             "WHERE { ?Team esports:Nationality ?Nationality . " +
                      "?Team a esports:Team . " +
                      "?Team esports:isNamed ?name . " +
                      "?name esports:simpleName ?TeamName . " +
                      "} ");
                break;
                
            default :
             _PremadeRequest = new String();
        }
        TxtArea_Request.setText(_PremadeRequest);
        Lbl_Description.setText(_PMRequestDescription);
    }//GEN-LAST:event_RequestPickerActionPerformed

    private void Bt_ResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Bt_ResetActionPerformed
       TxtArea_Request.setText("Type your request here ..");
    }//GEN-LAST:event_Bt_ResetActionPerformed

    private void ResultTypeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ResultTypeActionPerformed

        String ResultTypePicker= (String)ResultType.getSelectedItem();
        if (ResultTypePicker.equalsIgnoreCase("HTML visualization")){
            Txt_Panel.setContentType("text/html");
            Txt_Panel.setText(_resultHTML);
        } else {
            Txt_Panel.setContentType("text");
            Txt_Panel.setText(_resultXML);
        }
    }//GEN-LAST:event_ResultTypeActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Bt_Perform;
    private javax.swing.JButton Bt_Reset;
    private javax.swing.JLabel Lbl_Description;
    private javax.swing.JLabel Lbl_Status;
    private javax.swing.JPanel PanelPreMadeRequest;
    private javax.swing.JPanel PanelResults;
    private javax.swing.JComboBox RequestPicker;
    private javax.swing.JComboBox ResultType;
    private javax.swing.JTextArea TxtArea_Request;
    private javax.swing.JTextPane Txt_Panel;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    // End of variables declaration//GEN-END:variables

}
